Subject: bug#49265: [External] : bug#49265: 28.0.50; repeat mode feature request

From: Drew Adams <[email-masked]>
Date: Wed, 30 Jun 2021 15:11:07 +0000

>   >> Now a new command named 'describe-repeat' was pushed to master.
>   >> Please try it.  If everything is right, this request could be
>   >> closed.
> 
>   Drew> Where was it added to master?  I downloaded the latest
>   Drew> help-fns.el, and I don't see it there.  Could you perhaps
>   Drew> post the code here?  Could you perhaps say, here, just
>   Drew> what it does?  Thx.
> 
> Itʼs in repeat.el (and it does what I described 30 seconds ago, but
> better :-) )
> 
> Iʼm not sure what the use of showing the keymaps is though. Theyʼre an
> internal implementation detail, showing the potential bindings would
> be more useful.
> 
> (defun describe-repeat ()
>   "Describe repeatable commands and keymaps."

Again, that's wrong.  "Repeatable keymaps" doesn't
mean anything (to me, anyway).  If you mean describe
the keys bound to repeatable commands then say that.

>   (interactive)
>   (help-setup-xref (list #'describe-repeat)
>                    (called-interactively-p 'interactive))
>   (let ((keymaps nil))
>     (all-completions
>      "" obarray (lambda (s)
>                   (and (commandp s)
>                        (get s 'repeat-map)
>                        (push s (alist-get
>                                  (get s 'repeat-map)
>                                  keymaps)))))
>     (with-help-window (help-buffer)
>       (with-current-buffer standard-output
>         (princ "This is a list of repeatable keymaps and commands.\n\n")

Again, "repeatable keymaps" is a misnomer.

>         (dolist (keymap (sort keymaps (lambda (a b) (string-lessp (car a)
> (car b)))))
>           (princ (format-message "`%s' keymap is repeatable by these
> commands:\n"

How is a _keymap_ "repeatable"?